﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace mp3dll
{
    /// <summary>
    /// main class
    /// </summary>
    public partial class normalize : Form
    {
        /// <summary>
        /// normalize class
        /// </summary>
        public normalize()
        {
            InitializeComponent();
        }
        int number = 1;//player select
        private void normalize_Load(object sender, EventArgs e)
        {
            StringBuilder settings = new StringBuilder(1000);
            MP3.GetSettings(number, "otffm", settings, "0");

            if ("0" == settings.ToString())
            {
                otffast.CheckState = CheckState.Unchecked;
                MP3.EnableOnTheFlyVolumeNormalizationFast(number, 0);
            }
            else
            {
                otffast.CheckState = CheckState.Checked;
                MP3.EnableOnTheFlyVolumeNormalizationFast(number, 1);
                return;
            }

            MP3.GetSettings(number, "otf", settings, "0");

            if ("0" == settings.ToString())
            {
                otf.CheckState = CheckState.Unchecked;
                MP3.EnableOnTheFlyVolumeNormalization(number, 0);
            }
            else
            {
                //MessageBox.Show("foi ");
                otf.CheckState = CheckState.Checked;
                MP3.EnableOnTheFlyVolumeNormalization(number, 1);
                return;
            }

            MP3.GetSettings(number, "otfwfm", settings, "0");

            if ("0" == settings.ToString())
            {
                otfwtf.CheckState = CheckState.Unchecked;
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 0);
            }
            else
            {
                otfwtf.CheckState = CheckState.Checked;
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 1);
                return;
            }


            MP3.GetSettings(number, "otfw", settings, "0");

            if ("0" == settings.ToString())
            {
                oftw.CheckState = CheckState.Unchecked;
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 0);
            }
            else
            {
                oftw.CheckState = CheckState.Checked;
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 1);
                return;
            }



        }

        private void otffast_MouseUp(object sender, MouseEventArgs e)
        {

            MP3.SaveSettings(number, "otfw", "0");
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 0);
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 0);
            MP3.SaveSettings(number, "otfwfm", "0");
            MP3.EnableOnTheFlyVolumeNormalization(number, 0);
            MP3.SaveSettings(number, "otf", "0");
            MP3.SaveSettings(number, "otffm", "0");
            MP3.EnableOnTheFlyVolumeNormalizationFast(number, 0);

            otffast.CheckState = CheckState.Checked;
            otf.CheckState = CheckState.Unchecked;
            otfwtf.CheckState = CheckState.Unchecked;
            oftw.CheckState = CheckState.Unchecked;

            if (otffast.CheckState == CheckState.Checked)
            {
                MP3.SaveSettings(number, "otffm", "1");
                MP3.EnableOnTheFlyVolumeNormalizationFast(number, 1);
            }
            else
            {
                MP3.SaveSettings(number, "otffm", "0");
                MP3.EnableOnTheFlyVolumeNormalizationFast(number, 0);
            }
        }

        private void otf_MouseUp(object sender, MouseEventArgs e)
        {
            MP3.SaveSettings(number, "otfw", "0");
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 0);
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 0);
            MP3.SaveSettings(number, "otfwfm", "0");
            MP3.EnableOnTheFlyVolumeNormalization(number, 0);
            MP3.SaveSettings(number, "otf", "0");
            MP3.SaveSettings(number, "otffm", "0");
            MP3.EnableOnTheFlyVolumeNormalizationFast(number, 0);

            otffast.CheckState = CheckState.Unchecked;
            otf.CheckState = CheckState.Checked;
            otfwtf.CheckState = CheckState.Unchecked;
            oftw.CheckState = CheckState.Unchecked;
            //MP3.SaveSettings(number, "otffm", "1");

            if (otf.CheckState == CheckState.Checked)
            {
                MP3.EnableOnTheFlyVolumeNormalization(number, 1);
                MP3.SaveSettings(number, "otf", "1");
            }
            else
            {
                MP3.EnableOnTheFlyVolumeNormalization(number, 0);
                MP3.SaveSettings(number, "otf", "0");
            }
        }

        private void otfwtf_MouseUp(object sender, MouseEventArgs e)
        {

            MP3.SaveSettings(number, "otfw", "0");
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 0);
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 0);
            MP3.SaveSettings(number, "otfwfm", "0");
            MP3.EnableOnTheFlyVolumeNormalization(number, 0);
            MP3.SaveSettings(number, "otf", "0");
            MP3.SaveSettings(number, "otffm", "0");
            MP3.EnableOnTheFlyVolumeNormalizationFast(number, 0);

            otffast.CheckState = CheckState.Unchecked;
            otf.CheckState = CheckState.Unchecked;
            otfwtf.CheckState = CheckState.Checked;
            oftw.CheckState = CheckState.Unchecked;

            if (otfwtf.CheckState == CheckState.Checked)
            {
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 1);
                MP3.SaveSettings(number, "otfwfm", "1");
            }
            else
            {
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 0);
                MP3.SaveSettings(number, "otfwfm", "0");
            }
        }

        private void oftw_MouseUp(object sender, MouseEventArgs e)
        {

            MP3.SaveSettings(number, "otfw", "0");
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 0);
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 0);
            MP3.SaveSettings(number, "otfwfm", "0");
            MP3.EnableOnTheFlyVolumeNormalization(number, 0);
            MP3.SaveSettings(number, "otf", "0");
            MP3.SaveSettings(number, "otffm", "0");
            MP3.EnableOnTheFlyVolumeNormalizationFast(number, 0);


            otffast.CheckState = CheckState.Unchecked;
            otf.CheckState = CheckState.Unchecked;
            otfwtf.CheckState = CheckState.Unchecked;
            oftw.CheckState = CheckState.Checked;

            if (oftw.CheckState == CheckState.Checked)
            {
                MP3.SaveSettings(number, "otfw", "1");
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 1);
            }
            else
            {
                MP3.SaveSettings(number, "otfw", "0");
                MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 0);
            }
        }

        private void no_MouseUp(object sender, MouseEventArgs e)
        {
            otffast.CheckState = CheckState.Unchecked ;
            otf.CheckState = CheckState.Unchecked;
            otfwtf.CheckState = CheckState.Unchecked;
            oftw.CheckState = CheckState.Unchecked;

            MP3.SaveSettings(number, "otfw", "0");
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAG(number, 0);
            MP3.EnableOnTheFlyVolumeNormalizationAndWriteTAGFast(number, 0);
            MP3.SaveSettings(number, "otfwfm", "0");
            MP3.EnableOnTheFlyVolumeNormalization(number, 0);
            MP3.SaveSettings(number, "otf", "0");
            MP3.SaveSettings(number, "otffm", "0");
            MP3.EnableOnTheFlyVolumeNormalizationFast(number, 0);
        }
    }
}
